#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cmd.h"

/* Get a ptr of an object of DaqFileManager */
extern pDaqFM daqFMx;
/* array of t_cmds,key-value pairs of cmds and their cmd_Func */
struct t_cmd commands[NO_OF_COMMANDS] = {
        { "quit",   cmd_Func_quit },
        { "help",   cmd_Func_help },
		{ "dfp",	cmd_Func_dfp },
		{ "save",	cmd_Func_save},
		{"sample",cmd_Func_sample},
		{"csignal",cmd_Func_csignal},
		{"basicparam",cmd_Func_basicparam},
		{"smethod",cmd_Func_smethod},
		{"dfp", cmd_Func_dfp},
		{"samplerate",cmd_Func_samplerate},
		{"baud", cmd_Func_baud},
		{"fre",cmd_Func_fre},
		{"pp",cmd_Func_pp},
		{"mode",cmd_Func_mode},
		{"ipaddr",cmd_Func_ipaddr},
		{"mask",cmd_Func_mask},
		{"geteway",cmd_Func_gateway},
		{"serverip",cmd_Func_serverip},
		{"serverport",cmd_Func_serverport},
		{"sn",cmd_Func_sn},
		{"lon",cmd_Func_lon},
		{"la",cmd_Func_la},
		{"prints",cmd_Func_prints},
		{"printf",cmd_Func_printf},
		
};      
/* to check wether val is included in commands */
int FindInCmds(char* val)
{
	for (int i = 0;i < NO_OF_COMMANDS;i++) {
		if( 0==strcmp(commands[i].cmd,val) )
			return i;
	}
	return -1;
}

/*************************************************************
	
				Init method if DAQ config system

*************************************************************/
void Cmd_Init()
{
	
}

/************************************************************

				basic cmds of system

*************************************************************/
char cmd_Func_help()
{  
    (void) printf( "Usage: cmd \n" );
    (void) printf( "\n" );
    (void) printf( "Commands:\n" );
    (void) printf( "    help    print this help message\n" );
    (void) printf( "    quit    quit application\n" );
        
    return EXIT_SUCCESS;
}

char cmd_Func_quit()
{
    (void) printf( "Exiting ...\n" );
    exit( EXIT_SUCCESS );
}
/* ӡṹԪصֵ */
char cmd_Func_prints()
{
	printf("basicParam_chn:%s\n",daqFMx->_basicparam._chn);;
	return (EXIT_SUCCESS);
}
/* ӡļϢ */
char cmd_Func_printf()
{
	/* read info from config file and save to daq strc */
	DaqFM_Read(daqFMx);
	/* printf vals of all elems of info strct  */
	printf("sample_dfp:%s\n", daqFMx->_sample._dfp);;
	return (EXIT_SUCCESS);
}
/* Ϣдļ */
char cmd_Func_save()
{
	DaqFM_Save(daqFMx);
	return EXIT_SUCCESS;
}

/************************************************************

				ú 

*************************************************************/

/********************************  ********************************/
/* samlpe */
char cmd_Func_sample()
{
	cmd_Func_dfp();
	cmd_Func_samplerate();
	return EXIT_SUCCESS;
}
/* baud */
char cmd_Func_baud()
{
	char quit[] = { "quit" };
	char Val_1[] = { "9600" };
	char Val_2[] = { "115200" };
	char buffer[VALUELENGTH] = { '\0' };
	do {
		printf("please select value for baud\n");
		printf("%s %s\n", Val_1, Val_2);
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (!(strcmp(buffer, Val_1) || strcmp(buffer, Val_2)));

	/* ֵдṹ */
	DaqFM_SetVal_baud_baud(daqFMx, buffer);

	return EXIT_SUCCESS;
}

/* csignal */
char cmd_Func_csignal()
{
	cmd_Func_fre();
	cmd_Func_pp();
	return EXIT_SUCCESS;
}

/* smethod */
char cmd_Func_smethod()
{
	cmd_Func_mode();
	cmd_Func_ipaddr();
	cmd_Func_mask();
	cmd_Func_gateway();
	cmd_Func_serverip();
	cmd_Func_serverport();
	return EXIT_SUCCESS;
}
/* basicparam */
char cmd_Func_basicparam()
{
	cmd_Func_sn();
	cmd_Func_lon();
	cmd_Func_la();
	cmd_Func_chn();
	cmd_Func_model();
	return EXIT_SUCCESS;
}

/******************************** С ********************************/

/* dfp */
char cmd_Func_dfp()
{
	char quit[] = {"quit"};
	char Val_1[] = {"liner"};
	char Val_2[] = { "minimal" };
	char buffer[VALUELENGTH] = {'\0'};
	do{
		printf("please select value for dfp\n");
		printf("%s %s\n", Val_1, Val_2);
		(void)(void)scanf("%s",buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (!(strcmp(buffer, Val_1) || strcmp(buffer, Val_2)));
	
	DaqFM_SetVal_sample_dfp(daqFMx, buffer);
	return EXIT_SUCCESS;
}
/* samlperate */
char cmd_Func_samplerate()
{
	char quit[] = { "quit" };
	char buffer[VALUELENGTH] = { 0 };
	do {
		printf("please set value for fre\n");
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (strlen(buffer) == 0);

	/* ֵдṹ */
	DaqFM_SetVal_sample_samplerate(daqFMx, buffer);
	return EXIT_SUCCESS;
}
/* fre */
char cmd_Func_fre()
{
	char quit[] = { "quit" };
	char buffer[VALUELENGTH] = { 0 };
	do {
		printf("please set value for fre\n");
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (strlen(buffer) == 0);

	/* ֵдṹ */
	DaqFM_SetVal_csignal_fre(daqFMx, buffer);
	return EXIT_SUCCESS;
}
/* pp */
char cmd_Func_pp()
{
	char quit[] = { "quit" };
	char buffer[VALUELENGTH] = { 0 };
	do {
		printf("please set value for pp\n");
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (strlen(buffer) == 0);

	/* ֵдṹ */
	DaqFM_SetVal_csignal_pp(daqFMx, buffer);

	return EXIT_SUCCESS;
}
/* mode */
char cmd_Func_mode()
{
	char quit[] = { "quit" };
	char Val_1[] = { "master" };
	char Val_2[] = { "sliver" };
	char buffer[VALUELENGTH] = { '\0' };
	do {
		printf("please select value for dfp\n");
		printf("%s %s\n", Val_1, Val_2);
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (!(strcmp(buffer, Val_1) || strcmp(buffer, Val_2)));

	return EXIT_SUCCESS;
}
/* ipaddr */
char cmd_Func_ipaddr()
{
	char quit[] = { "quit" };
	char buffer[VALUELENGTH] = { 0 };
	do {
		printf("please set value for ipaddr\n");
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (strlen(buffer) == 0);

	/* ֵдṹ */
	DaqFM_SetVal_smethod_ipaddr(daqFMx, buffer);

	return EXIT_SUCCESS;
}
/* mask */
char cmd_Func_mask()
{
	char quit[] = { "quit" };
	char buffer[VALUELENGTH] = { 0 };
	do {
		printf("please set value for mask\n");
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (strlen(buffer) == 0);

	/* ֵдṹ */
	DaqFM_SetVal_smethod_mask(daqFMx, buffer);

	return EXIT_SUCCESS;
	return EXIT_SUCCESS;
}
/* gateway */
char cmd_Func_gateway()
{
	char quit[] = { "quit" };
	char buffer[VALUELENGTH] = { 0 };
	do {
		printf("please set value for gateway\n");
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (strlen(buffer) == 0);

	/* ֵдṹ */
	DaqFM_SetVal_smethod_gateway(daqFMx, buffer);

	return EXIT_SUCCESS;
	return EXIT_SUCCESS;
	return EXIT_SUCCESS;
}
/* serverip */
char cmd_Func_serverip()
{
	char quit[] = { "quit" };
	char buffer[VALUELENGTH] = { 0 };
	do {
		printf("please set value for serverip\n");
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (strlen(buffer) == 0);

	/* ֵдṹ */
	DaqFM_SetVal_smethod_serverip(daqFMx, buffer);


	return EXIT_SUCCESS;
}
/* serverport */
char cmd_Func_serverport()
{
	char quit[] = { "quit" };
	char buffer[VALUELENGTH] = { 0 };
	do {
		printf("please set value for serverport\n");
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (strlen(buffer) == 0);

	/* ֵдṹ */
	DaqFM_SetVal_smethod_serverport(daqFMx, buffer);
	return EXIT_SUCCESS;
}
/* sn */
char cmd_Func_sn()
{
	char quit[] = { "quit" };
	char buffer[VALUELENGTH] = { 0 };
	do {
		printf("please set value for sn\n");
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (strlen(buffer) == 0);

	/* ֵдṹ */
	DaqFM_SetVal_basicparam_sn(daqFMx, buffer);
	return EXIT_SUCCESS;
}
/* lon */
char cmd_Func_lon()
{
	char quit[] = { "quit" };
	char buffer[VALUELENGTH] = { 0 };
	do {
		printf("please set value for lon\n");
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (strlen(buffer) == 0);

	/* ֵдṹ */
	DaqFM_SetVal_basicparam_lon(daqFMx, buffer);
	return EXIT_SUCCESS;
}
/* la */
char cmd_Func_la()
{
	char quit[] = { "quit" };
	char buffer[VALUELENGTH] = { 0 };
	do {
		printf("please set value for la\n");
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (strlen(buffer) == 0);

	/* ֵдṹ */
	DaqFM_SetVal_basicparam_la(daqFMx, buffer);
	return EXIT_SUCCESS;
}
/*chn*/
char cmd_Func_chn()
{
	char quit[] = { "quit" };
	char buffer[VALUELENGTH] = { 0 };
	do {
		printf("please set value for chn\n");
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (strlen(buffer) == 0);

	/* ֵдṹ */
	DaqFM_SetVal_basicparam_chn(daqFMx, buffer);
	return EXIT_SUCCESS;
}
/*model*/
char cmd_Func_model()
{
	char quit[] = { "quit" };
	char buffer[VALUELENGTH] = { 0 };
	do {
		printf("please set value for model\n");
		(void)scanf("%s", buffer);
		if (!strcmp(buffer, quit))
			return EXIT_SUCCESS;
	} while (strlen(buffer) == 0);

	/* ֵдṹ */
	DaqFM_SetVal_basicparam_model(daqFMx, buffer);
	return EXIT_SUCCESS;
}


