#ifndef _CMD_H_
#define _CMD_H_

#include "daqfilemanager.h"

#define INPUT_LINE_LENGTH   21  /**< maximum length of command line including terminating zero                                          */
#define MAX_CMD_LENGTH      32   /**< maximum length of command string itself, including terminating zero                                */
#define NO_OF_COMMANDS      24   /**< number of commands, has to be changed whenever struct t_cmd commands[NO_OF_COMMANDS] is changed    */



/**
 *  cmd_Function pointer type for command evaluation.
 */
//typedef char (*t_cmd_cmd_Func)( const unsigned char argc, const char * argv[] );
typedef char (*t_cmd_cmd_Func)();
/**
 *  Command evaluation structure containing the string of the command
 *  itself and a cmd_Function pointer to the cmd_Function to be executed.
 */
struct t_cmd {
    char        cmd[MAX_CMD_LENGTH];    /**< command string     */
    t_cmd_cmd_Func  cmd_Func;                   /**< cmd_Function pointer   */
};

extern struct t_cmd commands[NO_OF_COMMANDS];
int FindInCmds(char* val);
/**
	funcCmd_Init()
	briefʼļϵͳ
	paramNone
	retvalNone
*/
void Cmd_Init();
/**
 *  Compare cmd_Function for qsort() and bsearch() comparing structures of
 *  type struct t_cmd.
 *
 *  @param[in]  e1  pointer to first struct
 *  @param[in]  e2  pointer to second struct
 *
 *  @return -1, 0 or 1 depending which is less, equal or greater.
 */
extern int cmd_cmp( const void *e1, const void *e2 );

/**
 *  Produce dummy error.
 *
 *  @param[in]  argc    number of arguments
 *  @param[in]  argv[]  list of null terminated argument strings
 *
 *  @return EXIT_FAILURE, yes, always!
 */
extern char cmd_Func_dummy();

/**
 *  Dump any memory content. Open for changing.
 *
 *  @param[in]  argc    number of arguments
 *  @param[in]  argv[]  list of null terminated argument strings
 *
 *  @return 0 in case of success, error value otherwise
 */
extern char cmd_Func_dump();

/**
 *  Print help message, nothing more.
 *
 *  @param[in]  argc    number of arguments
 *  @param[in]  argv[]  list of null terminated argument strings
 *
 *  @return 0 in case of success, error value otherwise
 */
char cmd_Func_help();

char cmd_Func_basicparam();
char cmd_Func_smethod();
char cmd_Func_csignal();
char cmd_Func_baud();
char cmd_Func_sample();

/*  */
char cmd_Func_quit();
char cmd_Func_prints();
char cmd_Func_printf();
char cmd_Func_save();
char cmd_Func_dfp();
char cmd_Func_samplerate();
char cmd_Func_baud();
char cmd_Func_fre();
char cmd_Func_pp();
char cmd_Func_mode();
char cmd_Func_ipaddr();
char cmd_Func_mask();
char cmd_Func_gateway();
char cmd_Func_serverip();
char cmd_Func_serverport();
char cmd_Func_sn();
char cmd_Func_lon();
char cmd_Func_la();
char cmd_Func_chn();
char cmd_Func_model();


char cmd_Func_csignal();




#endif
